﻿using System;
using System.Windows.Forms;

namespace HuxBot
{
	partial class HuxUI : Form
	{
		delegate void WriteTextFromServerCallback(string text);
		delegate void WriteTextToServerCallback(String cmd, String param, String message);
		IRCBot ircBot;
		public HuxUI(IRCBot bot)
		{
			ircBot = bot;
			InitializeComponent();
		}
		private void HuxUI_FormClosed(object sender, FormClosedEventArgs e)
		{
			ircBot.uiRunning = false;
		}
		public void WriteTextFromServer(String text)
		{
			if (this.mainTextBox.InvokeRequired)
			{
				WriteTextFromServerCallback d = new WriteTextFromServerCallback(WriteTextFromServer);
				this.Invoke(d, new object[] { text });
			}
			else
			{

				if (mainTextBox.Lines.Length == 200)
				{
					Char[] separator = { '\n' };
					mainTextBox.Text = mainTextBox.Text.Split(separator, 25)[24];
				}
				mainTextBox.AppendText(">> " + text + "\n");
			}
		}
		public void WriteTextToServer(string cmd, string param, string text)
		{
			if (this.mainTextBox.InvokeRequired)
			{
				WriteTextToServerCallback d = new WriteTextToServerCallback(WriteTextToServer);
				this.Invoke(d, new object[] { cmd, param, text });
			}
			else
			{

				if (mainTextBox.Lines.Length == 200)
				{
					Char[] separator = { '\n' };
					mainTextBox.Text = mainTextBox.Text.Split(separator, 25)[24];
				}
				mainTextBox.AppendText("<< " + "[" + param + "]" + " <" + ircBot.GetNickname() + "> " + text + "\n");
			}
		}

		private void inputBox_KeyDown(object sender, KeyEventArgs e)
		{
			if (e.KeyData == Keys.Enter)
			{

				ircBot.ParseFromUI(destTextBox.Text, inputBox.Text);
				inputBox.Clear();
				e.SuppressKeyPress = true;
			}
		}
	}
}
