﻿using System;
using System.IO;

namespace HuxBot
{
    struct IRCConfig
    {
        public string server;
        public int port;
        public string nick;
        public string name;
        public string chan;
        public string nspass;
        public string master;
        public string filepath;
        public string[] ignorelist;
        public string triggerpath;
        public string filterpath;
        public void ReadConfig(string path)
        {
            if (File.Exists(path))
            {
                using (StreamReader fs = new StreamReader(path))
                {
                    string line;
                    while ((line = fs.ReadLine()) != null)
                    {
                        string[] parameters = line.Split('=');
                        switch (parameters[0])
                        {
                            case "nick":
                                this.nick = parameters[1];
                                break;
                            case "server":
                                this.server = parameters[1];
                                break;
                            case "chan":
                                this.chan = parameters[1];
                                break;
                            case "nspass":
                                this.nspass = parameters[1];
                                break;
                            case "master":
                                this.master = parameters[1];
                                break;
                            case "filepath":
                                this.filepath = parameters[1];
                                break;
                            case "filter":
                                this.filterpath = parameters[1];
                                break;
                            case "ignore":
                                char[] delimit = { ',', ' ' };
                                this.ignorelist = parameters[1].Split(delimit);
                                break;
                        }
                    }
                }
                Console.WriteLine("Server: " + this.server + "\nChannel: " + this.chan + "\nNickname: " + this.nick + "\nMaster's nickname: " + this.master + "\nLog file: " + this.filepath);
            }
            else Console.WriteLine("Unable to read " + path + "!");
        }
    }
}
