﻿
using System.Text.RegularExpressions;
namespace HuxBot
{
	class IRCMessage
	{
		public string sender = null;
		public string name = null;
		public string netmask = null;
		public string mode = null;
		public string target = null;
		public string message = null;
		public string formatted = null;
        public bool isCTCP = false;
        string pat = "\u0001.+?\u0001";
		public IRCMessage(string input)
		{
			char[] del1 = { ' ' };
			string[] ex = input.Split(del1, 4);
			if (ex[0] == "PING")
			{
				this.mode = ex[0];
				this.message = ex[1];
			}
			else
			{
				this.mode = ex[1];
				char[] del = { ':', '!', '@' };
				string[] parse = ex[0].Split(del);
				this.sender = parse[1];
				switch (this.mode)
				{
					case "PRIVMSG":
						this.target = ex[2];
						this.message = ex[3].Substring(1);
						this.formatted = "[" + target + "]" + " " + "<" + sender + ">" + " " + message;
                        if (Regex.IsMatch(this.message, this.pat))
                            this.isCTCP = true;
						break;
					case "NOTICE":
						this.target = ex[2];
						this.message = ex[3].Substring(1);
						this.formatted = "-" + sender + "-" + " " + message;
						break;
					case "JOIN":
						this.target = ex[2].Substring(1);
						this.formatted = sender + " joined " + target;
						break;
					case "PART":
						this.target = ex[2].Substring(1);
						try
						{
							this.message = ex[3].Substring(1);
						}
						catch
						{
							this.message = null;
						}
						this.formatted = sender + " parted from " + target + " (" + message + ")";
						break;
					case "QUIT":
						switch (ex.Length)
						{
							case 4:
								this.message = ex[2].Substring(1) + ' ' + ex[3];
								break;
							case 3:
								this.message = ex[2].Substring(1);
								break;
						}
						this.formatted = sender + " quit " + "(" + message + ")";
						break;
					case "KICK":
						this.target = ex[2];
						this.message = ex[3];
						this.formatted = ex[3].Split(del1, 2)[0] + " was kicked by " + sender + " from " + target + " (" + ex[3].Split(del1, 2)[1] + ")";
						break;
					default:
						this.formatted = "<" + sender + ">" + " " + input.Split(del1, 2)[1];
						break;
				}
				try
				{
					this.name = parse[2];
					this.netmask = parse[3];
				}
				catch { }
			}
		}
	}
}
