﻿using System;
using System.Collections.Generic;
using System.Collections;
using System.IO;

namespace HuxBot
{
    class Trigger
    {
        private TimeCounter counter;
        private long secs;
        private string reply;
        private int timer;
        private List<string> repList;
        private int count;
        private Random rand;
        private bool isList;
        private string countpath;
        private Hashtable countlist;
        public Trigger(TimeCounter cnt, string rep, int tim = 0, string list = null, string countpath = null)
        {
            this.counter = cnt;
            this.secs = 0;
            if (rep.StartsWith("list:"))
            {
                repList = new List<string>();
                string path = rep.Substring(5);
                try
                {
                    this.rand = new Random();
                    using (StreamReader sr = new StreamReader(path))
                    {
                        string word;
                        while ((word = sr.ReadLine()) != null)
                        {
                            repList.Add(word);
                        }
                    }
                    this.count = repList.Count;
                    if (File.Exists(countpath))
                    {
                        this.countpath = countpath;
                        this.countlist = new Hashtable();
                        using (StreamReader sr = new StreamReader(this.countpath))
                        {
                            string line;
                            while ((line = sr.ReadLine()) != null)
                            {
                                string[] entry = line.Split('=');
                                this.countlist.Add(entry[0], Int32.Parse(entry[1]));
                            }
                        }
                    }
                    this.isList = true;
                }
                catch
                {
                    Console.WriteLine("File {0} is not acceptable as list file.", path);
                }
            }
            else
            {
                this.reply = rep;
                this.isList = false;
            }
            this.timer = tim;
        }
        public string Answer(string sender)
        {
            if (this.counter.getSecs() - this.secs >= this.timer)
            {
                try
                {
                    if (isList)
                    {
                        char[] del = { '|' };
                        string[] line = repList[rand.Next(count)].Split(del, 2);
                        if (line.Length > 1)
                        {
                            this.reply = line[0] + " by \u0002" + line[1];
                        }
                        else
                            this.reply = line[0];
                        try
                        {
                            this.countlist[sender] = (int)this.countlist[sender] + 1;
                        }
                        catch
                        {
                            this.countlist.Add(sender, 1);
                        }
                    }
                    this.secs = counter.getSecs();
                }
                catch { }
                return this.reply;
            }
            else return null;
        }
        public string Stats(string nick)
        {
            if (isList)
            {
                try
                {
                    int amnt = (int)countlist[nick];
                    return nick + " has used this trigger " + amnt + " times already.";
                }
                catch
                {
                    return nick + " hasn't used this trigger.";
                }
            }
            else
                return null;
        }
    }
}
